/************************************************************
3217 Phoenixville Pike
Malvern, PA  19355
800 321-5355 or 610 725-8800
http://www.lawsonlabs.com
VC++ demo. program for M40x A/D board,
Uses DLL: M40x.DLL to access M401
*************************************************************/


// M40xVC.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "M40xVC.h"
#include "M40xDlg.h"
#include "SetNewIP.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif




INDEX_CONTEXT  Context[MAX_M401];
UINT uSelected_Index;

/////////////////////////////////////////////////////////////////////////////
// CM40xVCApp

BEGIN_MESSAGE_MAP(CM40xVCApp, CWinApp)
	//{{AFX_MSG_MAP(CM40xVCApp)
	ON_COMMAND(ID_CONFIG_CONFIGM40X, OnConfigm40x)
	ON_COMMAND(ID_HELP_CONTENT, OnHelpContent)
	ON_COMMAND(ID_HELP_SEARCH, OnHelpSearch)
	ON_COMMAND( ID_HELP_INDEX, OnHelpIndex ) 
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CM40xVCApp construction

CM40xVCApp::CM40xVCApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CM40xVCApp object

CM40xVCApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CM40xVCApp initialization

/*************************************************************************
FUNCTION:	BOOL CM40xVCApp::InitInstance()

DESCRIPTION:


  * App entry point.

  * Loads M40x.dll and all its exported  functions

  * Creates and diplays main dialog box (modal) 

  * On App exit, when main dialog is closed, performs cleanup and unloads M40x.dll


RETURNS

	FALSE to stop message pump

*************************************************************************/

BOOL CM40xVCApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif
#ifdef _DEBUG
	hLibM40xCPP = LoadLibrary("M40x.dll");
#else
	hLibM40xCPP = LoadLibrary("M40x.dll");//dll should resident in the same directory
#endif
	if(!hLibM40xCPP){
		MessageBox(NULL,"Cannot find M40x.dll in the application folder\n.Terminating the application.","Error",MB_OK);
		return FALSE;
	}
	if(!LoadFunctions()){
		MessageBox(NULL,"Copy the latest version of M40x.dll to the application folder and try again.\n Terminating the application.","Error",MB_OK);
		return FALSE;
	}
	AfxInitRichEdit();
	CM40xVCDlg dlg;
	m_pMainWnd = &dlg;
	pdlg = &dlg;
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}	
	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.	
	pDLL_Exit();		//call to perform cleanup
	FreeLibrary(hLibM40xCPP);		
	return FALSE;
}



/************************************************************************
FUNCTION:	BOOL CM40xVCApp::LoadFunctions()

DESCRIPTION:

  *	Get address of following functions
		
		Pub_OpenConnection

		Pub_CloseConnection

		Pub_SetRate
		  
		Pub_SetChan
		
		Pub_EndScan

		Pub_SetDigOut

		Pub_SetRTC

		Pub_StartScan

		Pub_GetPolledConv

		Pub_OfsCal

		Pub_FsCal

		Pub_GetSelfTestRst

		Pub_SetNewIPAddr

		Pub_ResetScanDataObj

		Pub_ResetMinMax

		Pub_GetScanData

		Pub_PtrTransfer

		Pub_Exit

		DLL_Error_msg

RETURN

  TRUE - Success  

  FALSE - Failed 
**************************************************************************/
BOOL CM40xVCApp::LoadFunctions()
{
	if(!(pDLL_OpenConnection = (P_DLL_OPENCONNECTION)GetProcAddress
		(hLibM40xCPP,"Pub_OpenConnection"))){
		return FALSE;
	}
	if(!(pDLL_CloseConnection = (P_DLL_CLOSECONNECTION)GetProcAddress
		(hLibM40xCPP,"Pub_CloseConnection"))){
		return FALSE;
	}
	if(!(pDLL_SetRate = (P_DLL_SETRATE)GetProcAddress
		(hLibM40xCPP,"Pub_SetRate"))){
		return FALSE;
	}
	if(!(pDLL_SetChan = (P_DLL_SETCHAN)GetProcAddress
		(hLibM40xCPP,"Pub_SetChan"))){
		return FALSE;
	}
	if(!(pDLL_EndScan = (P_DLL_ENDSCAN)GetProcAddress
		(hLibM40xCPP,"Pub_EndScan"))){
		return FALSE;
	}
	if(!(pDLL_SetDigOut = (P_DLL_SETDIGOUT)GetProcAddress
		(hLibM40xCPP,"Pub_SetDigOut"))){
		return FALSE;
	}
	if(!(pDLL_SetRTC = (P_DLL_SETRTC)GetProcAddress
		(hLibM40xCPP,"Pub_SetRTC"))){
		return FALSE;
	}
	if(!(pDLL_StartScan = (P_DLL_STARTSCAN)GetProcAddress
		(hLibM40xCPP,"Pub_StartScan"))){
		return FALSE;
	}
	if(!(pDLL_GetPolledConv = (P_DLL_GETPOLLEDCONV)GetProcAddress
		(hLibM40xCPP,"Pub_GetPolledConv"))){
		return FALSE;
	}
	if(!(pDLL_OfsCal = (P_DLL_OFSCAL)GetProcAddress
		(hLibM40xCPP,"Pub_OfsCal"))){
		return FALSE;
	}
	if(!(pDLL_FsCal = (P_DLL_FSCAL)GetProcAddress
		(hLibM40xCPP,"Pub_FsCal"))){
		return FALSE;
	}
	if(!(pDLL_GetSelfTestRst = (P_DLL_GETSELFTESTRST)GetProcAddress
		(hLibM40xCPP,"Pub_GetSelfTestRst"))){
		return FALSE;
	}
	if(!(pDLL_SetNewIPAddr = (P_DLL_SETNEWIPADDR)GetProcAddress
		(hLibM40xCPP,"Pub_SetNewIPAddr"))){
		return FALSE;
	}
	if(!(pDLL_ResetScanDataObj = (P_DLL_RESETSCANDATAOBJ)GetProcAddress
		(hLibM40xCPP,"Pub_ResetScanDataObj"))){
		return FALSE;
	}
	if(!(pDLL_ResetMinMax = (P_DLL_RESETMINMAX)GetProcAddress
		(hLibM40xCPP,"Pub_ResetMinMax"))){
		return FALSE;
	}
	
	if(!(pDLL_PtrTransfer = (P_DLL_PTRTRANSFER)GetProcAddress
		(hLibM40xCPP,"Pub_PtrTransfer"))){
		return FALSE;
	}


	if(!(pDLL_GetScanData = (P_DLL_GETSCANDATA)GetProcAddress
		(hLibM40xCPP,"Pub_GetScanData"))){
		return FALSE;
	}

	if(!(pDLL_NoCallback = (P_DLL_NOCALLBACK)GetProcAddress
		(hLibM40xCPP,"Pub_NoCallback"))){
		return FALSE;
	}

	if(!(pDLL_Exit = (P_DLL_EXIT)GetProcAddress
		(hLibM40xCPP,"Pub_Exit"))){
		return FALSE;
	}
	

	if(!(pDLL_SetCallBackFunc = (P_DLL_SETCALLBACKFUNC)GetProcAddress
		(hLibM40xCPP,"Pub_SetCallBackFunc"))){
		return FALSE;
	}
	//07.02.03
	if(!(pDLL_ReadScanData = (P_DLL_READSCANDATA)GetProcAddress
		(hLibM40xCPP,"Pub_ReadScanData"))){
		return FALSE;

	}
	if(!(pDLL_NetworkEventThread = (P_DLL_NETWORKEVENTTHREAD)GetProcAddress
		(hLibM40xCPP,"Pub_NetworkEventThread"))){
		return FALSE;
	}
	if(!(pDLL_SetThreadPriority = (P_DLL_SETTHREADPRIORITY)GetProcAddress
		(hLibM40xCPP,"Pub_SetThreadPriority"))){
		return FALSE;
	}
	if(!(pDLL_ReadExScanDataDbl = (P_DLL_READEXSCANDATADBL)GetProcAddress(hLibM40xCPP,"Pub_ReadExScanDataDbl"))){
		return FALSE;
	}
	if(!(pDLL_GetMinMaxEffBits = (P_DLL_GETMINMAXEFFBITS)GetProcAddress(hLibM40xCPP,"Pub_GetExMinMaxEffBits"))){
		return FALSE;
	}
	if(!(pDLL_ExtendedScan = (P_DLL_EXTENDEDSCAN)GetProcAddress(hLibM40xCPP,"Pub_ExtendedScan"))){
		return FALSE;
	}
	if(!(pDLL_Error_Msg = (P_DLL_ERROR_MSG)GetProcAddress
		(hLibM40xCPP,"DLL_Error_msg"))){
		return FALSE;
	}	
	if(!(pDLL_GetLastError = (P_DLL_GETLASTERROR)GetProcAddress(hLibM40xCPP,"Pub_GetLastError"))){
		AfxMessageBox("This version of the M401 VC demo application requires a newer version of M40x.dll that supports Pub_GetLastError. Install version ??.??.????.? or later of M40x.dll and try again");
		return FALSE;
	}
	if(!(pDLL_GetScanTime = (P_DLL_GETSCANTIME)GetProcAddress(hLibM40xCPP,"Pub_GetScanTime"))){
		AfxMessageBox("This version of the M401 VC demo application requires a newer version of M40x.dll, one that supports Pub_GetScanTime. Install version ??.??.????.? or later of M40x.dll and try again");
		return FALSE;
	}
	if(!(pDLL_GetTimeDiff = (P_DLL_GETTIMEDIFF)GetProcAddress(hLibM40xCPP,"Pub_GetTimeDiff"))){
		AfxMessageBox("This version of the M401 VC demo application requires a newer version of M40x.dll, one that supports Pub_GetTimeDiff. Install version ??.??.????.? or later of M40x.dll and try again");
		return FALSE;
	}
	if(!(pDLL_IsFirmwareVersion = (P_DLL_ISFIRMWAREVERSION)GetProcAddress(hLibM40xCPP,"Pub_IsFirmwareVersionGreaterThanEqualTo"))){
		AfxMessageBox("This version of the M401 VC demo application requires a newer version of M40x.dll. Install version ??.??.????.? or later of M40x.dll and try again");
		return FALSE;
	}
	return TRUE;
}












/******************************************************************************
FUNCTION:	void CM40xVCApp::OnConfigm40x() 

DESCRIPTION:	

		* Display config modal box



RETURN

*******************************************************************************/
void CM40xVCApp::OnConfigm40x() 
{
	// TODO: Add your command handler code here
	CM40xVCDlg *pDlg;
	CSetNewIP dlg;
	if(dlg.DoModal() == IDOK){
		pDlg = (CM40xVCDlg *)this->m_pMainWnd;
		//M401 reboots after new config is recvd
		Context[uSelected_Index].bIsConnected = 0;
		pDlg->UpdateGUIState();
	}
}












/******************************************************************************
FUNCTION: 

DESCRIPTION:



RETURN

*******************************************************************************/

void CM40xVCApp::OnHelpContent() 
{
	// TODO: Add your command handler code here
}










/******************************************************************************
FUNCTION: 

DESCRIPTION:



RETURN

*******************************************************************************/
void CM40xVCApp::OnHelpSearch() 
{
	// TODO: Add your command handler code here
	
}








/******************************************************************************
FUNCTION: 

DESCRIPTION:



RETURN

*******************************************************************************/
void CM40xVCApp::OnHelpIndex() 
{
}




