/************************************************************
3217 Phoenixville Pike
Malvern, PA  19355
800 321-5355 or 610 725-8800
http://www.lawsonlabs.com
VC++ demo. program for M40x A/D board,
Uses DLL: M40x.DLL to access M401
*************************************************************/

// SetNewIP.cpp : implementation file
//



#include "stdafx.h"
#include "M40xVC.h"
#include "SetNewIP.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CSetNewIP dialog

extern CM40xVCApp theApp;
extern INDEX_CONTEXT  Context[MAX_M401];
extern UINT uSelected_Index;


CSetNewIP::CSetNewIP(CWnd* pParent /*=NULL*/)
	: CDialog(CSetNewIP::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSetNewIP)
	//}}AFX_DATA_INIT
}


void CSetNewIP::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetNewIP)
	DDX_Control(pDX, IDC_COMBO_ADRANGE, m_cmbADRange);
	DDX_Control(pDX, IDC_MSG, m_config_settings);
	DDX_Control(pDX, IDC_MAC_ADDR, m_mac_addr);
	DDX_Control(pDX, IDC_DHCP_TMOUT, m_dhcp_tmout);
	DDX_Control(pDX, IDC_SUBNETMASK, m_subnet_mask);
	DDX_Control(pDX, IDC_DOWNLOAD, m_download_btn);
	DDX_Control(pDX, IDC_GATEWAYIP, m_gateway_ip);
	DDX_Control(pDX, IDC_IPADDRESS, m_ip_newaddress);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetNewIP, CDialog)
	//{{AFX_MSG_MAP(CSetNewIP)
	ON_BN_CLICKED(IDC_DOWNLOAD, OnDownload)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetNewIP message handlers


BOOL CSetNewIP::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	CString tmpStr;
	char		SelfTstMsg[4096];
	char* selfTstMsgPtr = SelfTstMsg;
	char* selfTstMsgEndPtr;
	
	int nDHCPtmout;
	if(theApp.pDLL_GetSelfTestRst(&theApp.DLL_Scan_obj[uSelected_Index],SelfTstMsg) == COMMAND_OK){
		
		m_config_settings.SetWindowText("Settings saved in M401 board");		
//		theApp.pdlg->m_ip_address.GetWindowText(tmpStr);
		m_ip_newaddress.SetWindowText(theApp.pdlg->m_ip);
		selfTstMsgEndPtr = selfTstMsgPtr + strlen(selfTstMsgPtr);
		do{
			selfTstMsgPtr++;
		}while(strncmp("Net mask",selfTstMsgPtr,8) && (selfTstMsgPtr < selfTstMsgEndPtr));
		sscanf(selfTstMsgPtr,"Net mask. %s\n",theApp.pdlg->m_subnetmask);
		m_subnet_mask.SetWindowText(theApp.pdlg->m_subnetmask);
		do{
			selfTstMsgPtr++;
		}while(strncmp("Gateway IP.",selfTstMsgPtr,11) && (selfTstMsgPtr < selfTstMsgEndPtr));
		sscanf(selfTstMsgPtr,"Gateway IP. %s\n",theApp.pdlg->m_gateway_ip);
		m_gateway_ip.SetWindowText(theApp.pdlg->m_gateway_ip);
		do{
			selfTstMsgPtr++;
		}while(strncmp("DHCP timeout",selfTstMsgPtr,12) && (selfTstMsgPtr < selfTstMsgEndPtr));		
		sscanf(selfTstMsgPtr,"DHCP timeout.%d\n",&nDHCPtmout);
		theApp.pdlg->bDHCP_tmout = (BYTE)nDHCPtmout;
		tmpStr.Format("%d",theApp.pdlg->bDHCP_tmout);
		m_dhcp_tmout.SetWindowText(tmpStr);			
		//01.16.2007.10
		m_cmbADRange.SetCurSel(MapADRangeCodeToComboIndex(theApp.DLL_Scan_obj[uSelected_Index].bADRange));
		tmpStr.Format("%02x:%02x:%02x:%02x:%02x:%02x",
			theApp.DLL_Scan_obj[uSelected_Index].bMACAddr[0],theApp.DLL_Scan_obj[uSelected_Index].bMACAddr[1],
			theApp.DLL_Scan_obj[uSelected_Index].bMACAddr[2],theApp.DLL_Scan_obj[uSelected_Index].bMACAddr[3],
			theApp.DLL_Scan_obj[uSelected_Index].bMACAddr[4],theApp.DLL_Scan_obj[uSelected_Index].bMACAddr[5]);
		m_mac_addr.SetWindowText(tmpStr);		
	}
	else{
		AfxMessageBox("Self test failed. Check if the M401 is properly connected");
		return FALSE;
	}
	return TRUE;  // return TRUE unless you set the focus to a control
}

void CSetNewIP::OnDownload() 
{
	// TODO: Add your control notification handler code here
	DWORD	dwAddress,dwNetMask,dwGateWayAddr;
	BYTE	bTmOut;
	CString ipAddrStr,TmpStr;
	m_ip_newaddress.GetWindowText(ipAddrStr);
	m_ip_newaddress.GetAddress(dwAddress );
	m_subnet_mask.GetAddress(dwNetMask );
	m_gateway_ip.GetAddress(dwGateWayAddr );
	m_dhcp_tmout.GetWindowText(TmpStr);
	bTmOut = atoi(TmpStr);
	if(bTmOut > 15) bTmOut = 15;
	TmpStr.Format("%d",bTmOut);
	m_dhcp_tmout.SetWindowText(TmpStr);
	theApp.pdlg->bDHCP_tmout = bTmOut;
	//01.16.2007.10
	theApp.DLL_Scan_obj[uSelected_Index].bADRange = MapComboIndexToADRangeCode(m_cmbADRange.GetCurSel());

	theApp.pDLL_SetNewIPAddr(&theApp.DLL_Scan_obj[uSelected_Index],dwAddress,dwNetMask,dwGateWayAddr,bTmOut);	
	theApp.pDLL_CloseConnection(&theApp.DLL_Scan_obj[uSelected_Index]);
	theApp.pdlg->m_connect.SetWindowText("&Connect");
	theApp.pdlg->WriteLogEntry("Connection closed");
//	theApp.pdlg->m_ip_address.SetWindowText(ipAddrStr);
//	theApp.pdlg->SaveAllSettings();
	OnOK();
}

int CSetNewIP::MapADRangeCodeToComboIndex(BYTE bADRangeCode)
{
	int nReturn;
	switch(bADRangeCode){

		case 1:
			nReturn = 5;
			break;

		case 2:
			nReturn = 3;
			break;


		case 3:
			nReturn = 1;
			break;


		case 4:
			nReturn = 2;
			break;


		case 5:
			nReturn = 0;
			break;


		case 6:
			nReturn = 6;
			break;


		case 7:
			nReturn = 4;
			break;

		default:
			nReturn = 5; //default is 5 volts
			break;

	}
	return nReturn;
}

BYTE CSetNewIP::MapComboIndexToADRangeCode(int nComboIndex)
{
	BYTE bReturn;
	switch(nComboIndex){

		case 0:
			bReturn = 5;
			break;


		case 1:
			bReturn = 3;
			break;


		case 2:
			bReturn = 4;
			break;


		case 3:
			bReturn = 2;
			break;


		case 4:
			bReturn = 7;
			break;


		case 5:
			bReturn = 1;
			break;


		case 6:
			bReturn = 6;
			break;


		default:
			bReturn = 1;
			break;

	}
	return bReturn;

}
