/************************************************************
3217 Phoenixville Pike
Malvern, PA  19355
800 321-5355 or 610 725-8800
http://www.lawsonlabs.com
VC++ demo. program for M40x A/D board,
Uses DLL: M40x.DLL to access M401
*************************************************************/


// M40xVCDlg.h : header file
//

#if !defined(AFX_M40XVCAPPDLG_H__A9BDB543_D62B_4B6A_A30C_F5758073AFB7__INCLUDED_)
#define AFX_M40XVCAPPDLG_H__A9BDB543_D62B_4B6A_A30C_F5758073AFB7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <afxdao.h>
#include "resource.h"
#include "M40xDef.h"
#include "comboedit.h"
#define SINGLE_CHAN_SCAN		0x87
#define MULT_CHAN_SCAN			0x88
#define MULT_CHAN_CAL_SCAN		0x89
#define EXTENDED_SCAN			0xA2           //Extended scan token
#define EXTENDED_CAL_SCAN		0xA3
#include <afxcmn.h>
#include <afxmt.h>
#define MAX_M401 8
#define MAX_EXTRA_SETTING 20
/////////////////////////////////////////////////////////////////////////////
// CM40xVCDlg dialog

#include "ExScanSetupDlg.h"

#include "ExScanVoltDlg.h"


class CM40xVCDlg : public CDialog
{
// Construction
public:	
	void UpdateGUIState();
	BOOLEAN flgWaitForIndexSwitch;
	CMutex *pMutex;
	static void  EnterPressedInComboBox();
	BOOLEAN ReadNewScanData();
static	void CALLBACK EXPORT CM40xVCDlg::OnBlockRecv(void);
	BOOLEAN flgThreadRun;
	static UINT  ThreadProc(LPVOID pParam);	
	void Restore_Index_Context();
	CString		m_ip;					// ip address of M401 connected to this index
	CString		m_subnetmask;			// subnet mask of M401
	CString		m_gateway_ip;			// gateway of M401
	BYTE		bDHCP_tmout;			// DCHCP timout value of M401	
	void CloseOpenFile();				// see function definition for description - M40xDlg.cpp
	CM40xVCDlg(CWnd* pParent = NULL);	// standard constructor
	~CM40xVCDlg();						// destructor
	virtual void OnOK();				// function is empty	 
	void	SubWndIntLock(BYTE bState);
//	void	CreateLogFile(CString strFileName);
	void	UpdateLabel();
	void	EndScan();
	void	UpdateDigIn(BYTE bDigiStatus);
	void	UpdateDigiOut();
	void	PlotOnePixel(double fVoltage);
	void	WriteLogEntry(LPCTSTR pstrFormat, ...);
	BYTE	NumOfChan();
	void	SaveAllSettings();
  	static void CALLBACK OnTimerProc(HWND  hwnd, UINT  uMsg,	UINT  idEvent,	DWORD  dwTime);
	CDaoTableDef *m_pTableDef;			//Logging to Database not yet supported, ignore
	CDaoDatabase *m_pDatabase;			//Logging to Database not yet supported, ignore
	CDaoRecordset *m_pRecordSet;		//Logging to Database not yet supported, ignore
	unsigned long ulScanCnt;			//Total scan count
	CWnd*	m_pChanReading[8];			
	CString	strTmp;
	FILE*	pScanDataLogFile[MAX_M401]; //File pointer to save scan points, one for each index
	FILE*	pEventLogFile[MAX_M401]; //File pointer to save log of events shown in list box, one for each index
	FILE*	pConfigFile;			//File pointer to M40x.cfg file which stores settings of each index
	char	LogFileName[128];
	bool	bIsTextLogFile;			//ignore	
// Dialog Data
	//{{AFX_DATA(CM40xVCDlg)
	enum { IDD = IDD_VC_DLG };
	CButton	m_BtnResetMaxMin;
	CButton	m_BtnExScanSetup;
	CButton	m_ChkExtended;
	CRichEditCtrl	m_Scan_Error;
	CStatic	m_data_acq_method;
	CComboBox m_ip_address_combo;
	CStatic	m_Time;
	CButton	m_Show_Error;	
	CStatic	m_scan_counts;
	CButton	m_set_rtc;
	CButton	m_self_test;
	CButton	m_init_dev;
	CButton	m_sys_cal_btn;
	CButton	m_set_rate_btn;
	CStatic	m_scan_rate;
	CButton	m_dac2_output;
	CEdit	m_dac2_edit;
	CButton	m_dac1_output;
	CEdit	m_dac1_edit;
	CButton	m_dac0_output;
	CEdit	m_dac0_edit;
	CButton	m_end_scan;
	CButton	m_start_btn;
	CButton	m_cal_scan_check;
	CComboBox	m_num_of_chan;
	CButton	m_multi_chan;
	CButton	m_event_log_save_checked;
	CListBox	m_evt_log_wnd;
	CEdit	m_rate_edit;
	CStatic	m_sec_p_div;
	CComboBox	m_chan_sel;
	CComboBox	m_volt_div_combo;
	CComboBox	m_dc_ac_sel;
	CStatic	m_lcd_screen;
	CComboBox	m_avg_combo;
	CStatic	m_effective_bits;
	CStatic	m_delta_dsp;
	CStatic	m_std_devi;
	CStatic	m_min_dsp;
	CStatic	m_max_dsp;
	CButton	m_save_log_file;
	CStatic	m_read_v0;
	CStatic	m_read_v1;
	CStatic	m_read_v2;
	CStatic	m_read_v3;
	CStatic	m_read_v4;
	CStatic	m_read_v5;
	CStatic	m_read_v6;
	CStatic	m_read_v7;
	CButton		m_sel_ch0;
	CButton		m_sel_ch1;
	CButton		m_sel_ch2;
	CButton		m_sel_ch3;
	CButton		m_sel_ch4;
	CButton		m_sel_ch5;
	CButton		m_sel_ch6;
	CButton		m_sel_ch7;
	CStatic		m_led_red8;
	CStatic		m_led_red7;
	CStatic		m_led_red6;
	CStatic		m_led_red5;
	CStatic		m_led_red4;
	CStatic		m_led_red3;
	CStatic		m_led_red2;
	CStatic		m_led_red1;
	CStatic		m_led_gray8;
	CStatic		m_led_gray7;
	CStatic		m_led_gray6;
	CStatic		m_led_gray5;
	CStatic		m_led_gray4;
	CStatic		m_led_gray3;
	CStatic		m_led_gray2;
	CStatic		m_led_gray1;
	CButton		m_do_d0;
	CButton		m_do_d1;
	CButton		m_do_d2;
	CButton		m_do_d3;
	CButton		m_do_d4;
	CButton		m_do_d5;
	CButton		m_do_d6;
	CButton		m_do_d7;
	CButton		m_connect;
	CButton		m_polled_radio;
	CButton		m_scan_radio;
	//}}AFX_DATA
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CM40xVCDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL
// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CM40xVCDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnDestroy();
	afx_msg void OnExit();
	afx_msg void OnPaint();
	afx_msg void OnConnect();
	afx_msg void OnStartBtn();
	afx_msg void OnSetRTC();
	afx_msg void OnEndScan();
	afx_msg void OnSysCal();
	afx_msg void OnInitialization();
	afx_msg void OnSelchangeAvgCombo();
	afx_msg void OnDoD7();
	afx_msg void OnDoD6();
	afx_msg void OnDoD5();
	afx_msg void OnDoD4();
	afx_msg void OnDoD3();
	afx_msg void OnDoD2();
	afx_msg void OnDoD1();
	afx_msg void OnDoD0();
	afx_msg void OnCh0();
	afx_msg void OnCh1();
	afx_msg void OnCh2();
	afx_msg void OnCh3();
	afx_msg void OnCh4();
	afx_msg void OnCh5();
	afx_msg void OnCh6();
	afx_msg void OnCh7();
	afx_msg void OnSelChangVoltDivComb();
	afx_msg void OnSelChangDcAcComb();
	afx_msg void OnMultiChan();
	afx_msg void OnSelchangeNumChan();
	afx_msg void OnCalScan();
	afx_msg void OnSelchangeChanSel();
	afx_msg void OnPolledRadio();
	afx_msg void OnScanRadio();
	afx_msg void OnMaxminReset();
	afx_msg void OnSetRate();
	afx_msg void OnSelfTest();
	afx_msg void OnFileExit();
	afx_msg void OnHelpAbout();
	afx_msg void OnEditAvgCombo();
	afx_msg void OnHelp();
	afx_msg void OnEditchangeIpAddressCombo();
	afx_msg void OnSelchangeIpAddressCombo();
	afx_msg void OnEvtLogSave();
	afx_msg void OnShowError();
	afx_msg void OnInHouseOnly();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnThreadPriorityHighest();
	afx_msg void OnThreadPriorityAboveNormal();
	afx_msg void OnThreadPriorityNormal();
	afx_msg void OnThreadPriorityBelowNormal();
	afx_msg void OnThreadPriorityLowest();
	afx_msg void OnThreadPriorityIdle();
	afx_msg void OnExScanSetup();
	afx_msg void OnChkExtended();
	afx_msg void OnButton1();
	afx_msg void OnButton2();
	afx_msg void OnFileRtchosttimediff();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	HICON m_hIcon,m_hIconGray,m_hIconBlue;
private:			
	CBitmap MemBmp, SaveBmp;
	CDC SaveMemDC;
	double fPlot_X;
	double fSecsPerScrn;
	double fXPixPerDP;
	BYTE GetExActiveChan();
	void SetSubChan(BYTE bSubChan);
	BOOLEAN ReadNewExScanData(UINT uIndex);
	CExScanVoltDlg m_ExVoltDlg;
	CExScanSetupDlg ExSetupDlg;	
	void SetMenuThreadPriority(BYTE bThreadPriority);
	BOOLEAN flgUsingEventThread;
	BYTE bNetworkEventThreadPriority;
	BYTE bNetworkPollThreadPriority;
	void LoadExtraSetting(FILE *fptr);
	BOOLEAN GetSettingValue(int nIndexPos, FILE *fptr,const char *pSearchTag, char *pValue);
	int GetNextIndexPos(int nPrevIndexPos, FILE *fptr, char *pIP);
	CComboEdit m_ip_edit;
	int nNumExtraSetting;
	CString pExtraSetting[MAX_EXTRA_SETTING];
	BOOLEAN flgNoCallback;
//	void GetNewScanData();
	BOOLEAN CheckForKeyword(const char * pKeyword);
	BOOLEAN flgUsingThreadForDataAcq;
	CWinThread* pDataAcqThread;
	UINT UpdateClockID;			//1sec timer to update clock
	DWORD dwEndTimeout;
	void DisableShowError();
	void EnableShowError();
	void Get_IP_Params();
	int ParseLine(char *pLine,char *pToken);
	void Init_Index_Context();
	void Wrong_IP_Entered();
	int nIP_Index;
	BOOLEAN Check_IP(CString s,CString& nResult);
	void Save_Index_Context();
	BYTE bLastDigOut;
	BOOL bIsEverConnected;
	BOOL LoadAllSettings();
	void		SaveScanDataDlg();
	BYTE		bPlotSelChan;
	void		UpDateAllDsp(void);
	void		WriteScanLogFile(UINT uIndex);
	BYTE		GetCurChanSel();
	void		OnChComm(BYTE bCHClicked);
	void		ClsPlotScrn(void);
	void		InitAllFonts(void);
	double		fSecPerDiv;
	double		fOffSet;//Offset for plot window fOffSet = 0; when slider is in the middle
	double		fPixPerVolt;//Dots/Volts, it depends on sensitivity
	double		fOffSetVolt;
	//BYTE		bScanMode;
	BYTE		bScanChanCnt;
	BYTE		bChanScanAvg;
	CFont*		m_pFont1;
	CFont*		m_pFont2;
	LOGFONT		m_Font1;
	LOGFONT		m_Font2;
	CButton*	m_pChanSel[8];
	CButton*	m_pDigiOut[8];
	CDC			GraphDC, MemDC;	//MemDC keeps a copy of the graph background to be restored
	//later during plotting.
	CPen*		m_pYlwPen;
	CPen*		m_pBlkPen;
	RECT		LCD_RECT;
	COLORREF	m_bkColor0;
	COLORREF	m_bkSaved;
	CBrush		bkBrush;
	BYTE		bIsAC;
	UINT		ulPixPer10thScaleX;
	UINT		ulPixPer10thScaleY;
	INT			nLastPlot_Y;
	INT			nLastPlot_X;
	//UINT		nPlot_X;
	//UINT		nPrev_Y[640];//recorded previous Y coodinate(for erasing)
	UINT		ulCenter;// Center coordinate ulCenter = LCD_RECT.bottom /2 
	UINT		ulTotalLogLines;
	time_t		t1, t2;
	UINT		TimerID;
	BYTE		bCurSelChan;
	BYTE		bIconToggle;
	UINT		m_port;
	RETURN_CODE wErr_ret;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.


#endif // !defined(AFX_M40XVCAPPDLG_H__A9BDB543_D62B_4B6A_A30C_F5758073AFB7__INCLUDED_)

